/**
 * Bulk State Transfer for Anti-Entropy
 *
 * send new states in "nstate" from "table" to "peer" via "tcp"
 * then enable direct forwarding & send DataRplyCmpl to "peer"
 *
 * (c) Columbia University, 2001-2004, All Rights Reserved.
 * Author: Weibin Zhao
 */

import java.net.*;
import java.util.*;

class bulkTrans extends Thread {

    slpTcpHandler tcp;
    slpMsgComposer composer;
    String peer;
    Vector nstate, adaList, atsList;
    int rxid;
    da daf;

    bulkTrans(slpTcpHandler tcp, Vector nstate, String peer, 
              int rxid, Vector adaList, Vector atsList, da daf) {
        this.tcp   = tcp;
        this.nstate = nstate;
        composer = new slpMsgComposer();
        this.peer = peer;
        this.rxid = rxid;
        this.adaList = adaList;
        this.atsList = atsList;
        this.daf = daf;
    }

    public void run() {
        int ltime;
        Entry  e;
        byte[] buf;
        long ctime = System.currentTimeMillis()/1000;
        for (int i=0; i<nstate.size(); i++) {
            e = (Entry) nstate.elementAt(i);
            ltime = (int)(e.getArrivalTS()/1000 + e.getLifetime() - ctime);
            buf = composer.SrvReg(0, Const.fresh_flag, e.getLtag(), e.getURL(),
                         ltime, e.getType(), e.getScope(), e.getAttr("")); 
            buf = composer.MeshFwdExt(buf, Const.Fwded, e.getVersionTS(),
                                      e.getAcceptDA(), e.getAcceptTS());
            tcp.send(buf, buf.length);
            if (e.getDeleted()) {
                buf = composer.SrvDeReg(0, e.getLtag(), e.getScope(),
                                        e.getURL(), ltime, "");
                buf = composer.MeshFwdExt(buf, Const.Fwded, e.getVersionTS(),
                                          e.getAcceptDA(), e.getAcceptTS());
                tcp.send(buf, buf.length);
            } 
        }
        daf.AntiEtrpRqst_Handler2(peer, rxid, adaList, atsList);
    }
}
